]> git.sesse.net Git - backup.sh/blob - backup.sh
Englishify a bit.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # KISS. And by that I mean really simple. Only regular Unix commands, please
15 # (but GNU extensions are used and moreutils has to be installed).
16 #
17 # Because of the way we run this script from cron, informational logging goes
18 # to stderr and warnings and errors to stdout. This way, we get mail whenever
19 # stuff fails, and other output is redirected to the log file.
20
21 # The script is halfway Norwegian and halfway English. Newer modifications are
22 # in English, we should probably stick to that.
23
24 # The computer to backup.
25 computer=$1
26
27 # Configuration
28 LOCKFILE=/home/backup/backuprun.lockfile.$computer
29 confdir=/home/backup/conf/              # Configuration files
30 storagedir=/backup                      # Where we keep backups
31 maksantallfulle=3                       # Number of full backups
32 dagermellomfulle=30                     # Days between full backups
33 dagermellomfulleforfast=32              # Days between full backups for machines with fixed
34                                         # full-backup date (in case the fixed day gets missed)
35 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
36 DATE=`date "+%Y%m%d%H%M"`               #format: touch
37 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
38
39 # Exclude-pattern
40 exclude=$confdir/exclude
41 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
42
43 if [ -z "$computer" ]; then
44         echo "Usage: $0 COMPUTER"
45         exit 1
46 fi
47
48 # Die more or less gracefully (at least notify user)
49 die() {
50         echo `date`": Something nasty happened. Ending, and not deleting lockfile $LOCKFILE."
51         exit 1
52 }
53
54 # Trap C-c and kill
55 trap die SIGINT SIGTERM
56
57 # Don't start if we're already running
58 if [ -e $LOCKFILE ]; then
59         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
60         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
61         exit 1
62 fi;
63 touch $LOCKFILE
64 echo $$ > $LOCKFILE
65
66 echo `date`": Backup run starting" >&2
67
68 umask 027
69
70
71 backup()
72 {
73
74  echo -n `date` >&2
75  printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
76
77  SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
78  incrementalsnar="/root/.backup/${sfilesystem}.snar"
79  if [ "$backuplevel" = "daglig" ]
80  then
81    # If incremental backup, we need to copy the incremental status to $computer.
82    # If it does not exist, whine a bit and then run date-based instead.
83    if [ -s "$SNARFILE" ]; then
84      if ! scp $SNARFILE root@$computer:$incrementalsnar; then
85        echo `date`" $computer: Could not copy .incremental.snar to $computer"
86        die
87      fi
88      lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
89    else
90      echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
91      incrementalsnar=""
92      lastd=`cat ../.date`
93      lastcmd="--newer='$lastd'"
94    fi
95  else
96     lastcmd="--listed-incremental=$incrementalsnar"
97  fi
98
99  # expand the exclude-path for use with tar
100  exf=`ssh root@$computer "ls ~/.backup/exclude"`
101
102  # We try to run tar on the remote computer
103  #    c create archive
104  #    C change to directory first
105  #    . where to start taring (see C)
106  #    $lastcmd only files newer than this
107  #    --one-file-system don't traverse file systems
108  #    --use-compress-program compress it using gzip or pigz
109  #    --exclude-from file to get exclusion pattern from
110  #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
111  #    file and build a file list, respectivly.  
112  TARFILE=$DATE.tmp
113  TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
114         --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
115  echo `date`" $computer: Running $TARCMD" >&2
116  eval $TARCMD > $DATE.idx
117
118  if [ $? -eq 0 ] && [ -s $TARFILE ]; then
119   # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
120
121   if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
122     echo `date`" $computer: Could not copy .incremental.snar from $computer"
123     die
124   fi
125
126   # Move tar file in place
127   mv $TARFILE $DATE.tgz
128   mv $SNARFILE.tmp $SNARFILE
129
130   # Update timestamp
131   echo $DATEs > ../.date && touch -t $DATE ../.date
132
133   # Make a sorted file list as well
134   sort -k6 < $DATE.idx > $DATE.sdx
135
136   # Fix permissions
137   chmod 600 *tgz                      #only for us
138   chmod 644 *sdx *idx 2>/dev/null     #everyone can read
139
140   # Let the remote computer know that we ran a successful backup (for nagios)
141   ssh root@$computer touch $filesystem/.lastbackup
142
143  else
144   # Something wrong happened.
145   rm $TARFILE
146   echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
147   die
148  fi
149
150 }
151
152  # Check that the target filesystem is mounted (actually check that it's not
153  # the root filesystem)
154  if [ ! -d "$storagedir/$computer" ]; then
155         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
156         die
157  fi
158  rootfilesystem=`df -P /`
159  targetfilesystem=`df -P "$storagedir/$computer"`
160  if [ "$rootfilesystem" == "$targetfilesystem" ]; then
161         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
162         die
163  fi
164
165  echo `date`" $computer: Backing up $computer" >&2
166
167  # Try to SSH to the computer without entering a password.
168  if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
169   echo `date`" $computer: Could not use passwordless SSH."
170   die
171  fi
172
173  # Check if pigz is available
174  if ssh -n root@$computer "pigz -V 2>/dev/null"; then
175    compressor=pigz
176  else
177    echo `date`" $computer: pigz missing; falling back to gzip."
178    compressor=gzip
179  fi
180  
181  # Check dump bit in fstab
182  filesystems=`ssh -n root@$computer "cat /etc/fstab" \
183   | grep -v nfs \
184   | grep -v "^#" \
185   | grep -v "^$" \
186   | awk '{ if ( $(NF-1) != "0" ) print $2}' `
187
188  # Clean up our dir at this client
189  if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
190   echo `date`" $computer: Could not create backup staging area at $computer:~/.backup"
191   die
192  fi
193
194  # Try to copy $exclude to $computer
195  if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
196   echo `date`" $computer: Could not copy exclude.txt to $computer"
197   die
198  fi
199
200  # Try to copy preeexec and postexec if they exist
201  if [ -f $confdir/preexec.$computer ]; then
202    if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
203      echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec"
204      die
205    fi
206  fi
207  if [ -f $confdir/postexec.$computer ]; then
208    if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
209      echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec"
210      die
211    fi
212  fi
213
214  # Try to run preexec if it exists
215  if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
216         echo `date`" $computer: Could not run $computer:~/.backup/preexec"
217         die
218  fi
219
220
221  for filesystem in $filesystems
222  do
223   # Remove / and $ (for Windows) for path names
224   sfilesystem=`echo $filesystem | tr '\/\$' '__'`
225
226   # Prepare storage area
227   mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
228   mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
229
230   # Default backuplevel
231   backuplevel=daglig
232
233   if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
234   then
235    # Take the first full backup of this filesystem on this computer
236    backuplevel=full
237    echo $DATEs > $storagedir/$computer/$sfilesystem/.date
238   fi
239
240   # Check if we want a full backup
241   if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
242     fullbackup_min_for_this_machine=$dagermellomfulleforfast
243     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
244       backuplevel=full
245     fi
246   elif [ -f $confdir/fastfullbackupdag.$computer ]; then
247     fullbackup_min_for_this_machine=$dagermellomfulleforfast
248     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
249       backuplevel=full
250     fi
251   else
252     fullbackup_min_for_this_machine=$dagermellomfulle 
253   fi
254
255   if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
256    backuplevel=full
257   fi
258
259   # We want to be here
260   cd $storagedir/$computer/$sfilesystem/$backuplevel || die
261
262   # Perform the actual backup
263   backup
264
265   # Check if this box has a custom number of full backups
266   if [ -f $confdir/maksfulle.$computer ] ; then
267     mf=$((`cat $confdir/maksfulle.$computer`+1))
268   else
269     mf=$(($maksantallfulle+1))
270   fi
271
272   # Delete old full backups
273   for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
274   do
275    prefix=`echo $full | sed "s/\.[^.]*$//"`
276    echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
277    rm $prefix*
278   done
279
280   # Delete incremental backups older than the oldest full backup
281   oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
282   find \
283      $storagedir/$computer/$sfilesystem/daglig \
284      -type f \
285      \! -newer $oldf \
286      -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
287      -exec rm {} \; >&2
288  done
289
290  # Try to run postexec if it exist
291  if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
292         echo `date`" $computer: Could not run $computer:~/.backup/postexec"
293         die
294  fi
295
296 # Remove lockfile
297 rm $LOCKFILE